# Class XyoWitnessWrapper

### Deprecated

use WitnessWrapper instead

#### Hierarchy

- WitnessWrapper
  - XyoWitnessWrapper

- Defined in modules/packages/witness/dist/types/WitnessWrapper.d.ts:9

#####
Index

### Constructors

constructor

### Properties

eventData
params
wrapperParams
defaultLogger?
requiredQueries

### Accessors

account
address
config
downResolver
logger
module
queries
upResolver

### Methods

bindQuery
bindQueryInternal
clearListeners
describe
discover
emit
emitSerial
filterErrors
listenerCount
observe
off
offAny
on
onAny
once
previousHash
query
queryable
resolve
resolveWrapped
sendQuery
throwErrors
canWrap
hasRequiredQueries
missingRequiredQueries
tryWrap
wrap

## Constructors

### constructor

- new XyoWitnessWrapper(params): XyoWitnessWrapper

- #### Parameters

  - ##### params: BaseParamsFields & {
    account?: AccountInstance;
    module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>;
    }

  #### Returns XyoWitnessWrapper

  Inherited from WitnessWrapper.constructor

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:29

## Properties

### eventData

eventData: ModuleEventData

Inherited from WitnessWrapper.eventData

- Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:27

### `Readonly` params

params: ModuleParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.module.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<undefined, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>

Inherited from WitnessWrapper.params

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:20

### `Protected` `Readonly` wrapperParams

wrapperParams: BaseParamsFields & {
account?: AccountInstance;
module: Module<ModuleParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.module.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<undefined, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>, ModuleEventData>;
}

Inherited from WitnessWrapper.wrapperParams

- Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:28

### `Static` `Optional` defaultLogger

defaultLogger?: Logger

Inherited from WitnessWrapper.defaultLogger

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:21

### `Static` requiredQueries

requiredQueries: string[]

Inherited from WitnessWrapper.requiredQueries

- Defined in modules/packages/witness/dist/types/WitnessWrapper.d.ts:5

## Accessors

### account

- get account(): undefined | AccountInstance

- #### Returns undefined | AccountInstance

  Inherited from WitnessWrapper.account

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:30

### address

- get address(): string

- #### Returns string

  Inherited from WitnessWrapper.address

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:31

### config

- get config(): TWrappedModule["config"]

- #### Returns TWrappedModule["config"]

  Inherited from WitnessWrapper.config

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:32

### downResolver

- get downResolver(): ModuleResolver

- #### Returns ModuleResolver

  Inherited from WitnessWrapper.downResolver

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:33

### `Protected` logger

- get logger(): Logger | Console

- #### Returns Logger | Console

  Inherited from WitnessWrapper.logger

  - Defined in protocol/packages/core/dist/types/lib/Base.d.ts:23

### module

- get module(): TWrappedModule

- #### Returns TWrappedModule

  Inherited from WitnessWrapper.module

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:34

### queries

- get queries(): string[]

- #### Returns string[]

  Inherited from WitnessWrapper.queries

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:35

### upResolver

- get upResolver(): ModuleResolver

- #### Returns ModuleResolver

  Inherited from WitnessWrapper.upResolver

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:36

## Methods

### `Protected` bindQuery

- bindQuery<T>(query, payloads?, account?): PromiseEx<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]], AccountInstance>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` account: AccountInstance

  #### Returns PromiseEx<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]], AccountInstance>

  Inherited from WitnessWrapper.bindQuery

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:71

### `Protected` bindQueryInternal

- bindQueryInternal<T>(query, payloads?, account?): Promise<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` account: AccountInstance

  #### Returns Promise<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

  Inherited from WitnessWrapper.bindQueryInternal

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:72

### clearListeners

- clearListeners(eventNames): void

- #### Parameters

  - ##### eventNames: keyof ModuleEventData | (keyof ModuleEventData)[]

  #### Returns void

  Inherited from WitnessWrapper.clearListeners

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:42

### describe

- describe(): Promise<Promise<Promisable<ModuleDescription, never>>>

- #### Returns Promise<Promise<Promisable<ModuleDescription, never>>>

  Inherited from WitnessWrapper.describe

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:43

### discover

- discover(): Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

- #### Returns Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

  Inherited from WitnessWrapper.discover

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:44

### emit

- emit(eventName, eventArgs): Promise<void>

- #### Parameters

  - ##### eventName: keyof ModuleEventData

  - ##### eventArgs: EventArgs

  #### Returns Promise<void>

  Inherited from WitnessWrapper.emit

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:45

### emitSerial

- emitSerial(eventName, eventArgs): Promise<void>

- #### Parameters

  - ##### eventName: keyof ModuleEventData

  - ##### eventArgs: EventArgs

  #### Returns Promise<void>

  Inherited from WitnessWrapper.emitSerial

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:46

### `Protected` filterErrors

- filterErrors(query, result): (null | SchemaFields & PayloadFields & {
  message?: string;
  schema: "network.xyo.error.module";
  sources?: string[];
  })[]

- #### Parameters

  - ##### query: [SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }, (SchemaFields & PayloadFields & {
    schema: string;
    })[]]

  - ##### result: undefined | ModuleQueryResult<SchemaFields & PayloadFields & {
    schema: string;
    }>

  #### Returns (null | SchemaFields & PayloadFields & {
  message?: string;
  schema: "network.xyo.error.module";
  sources?: string[];
  })[]

  Inherited from WitnessWrapper.filterErrors

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:73

### listenerCount

- listenerCount(eventNames): number

- #### Parameters

  - ##### eventNames: keyof ModuleEventData | (keyof ModuleEventData)[]

  #### Returns number

  Inherited from WitnessWrapper.listenerCount

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:47

### observe

- observe(payloads?): Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

- #### Parameters

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

  Inherited from WitnessWrapper.observe

  - Defined in modules/packages/witness/dist/types/WitnessWrapper.d.ts:6

### off

- off<TEventName>(eventNames, listener): void

- #### Type Parameters

  - #### TEventName extends keyof ModuleEventData

  #### Parameters

  - ##### eventNames: TEventName

  - ##### listener: EventListener<ModuleEventData[TEventName]>

  #### Returns void

  Inherited from WitnessWrapper.off

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:48

### offAny

- offAny(listener): void

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns void

  Inherited from WitnessWrapper.offAny

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:49

### on

- on<TEventName>(eventNames, listener): EventUnsubscribeFunction

- #### Type Parameters

  - #### TEventName extends keyof ModuleEventData

  #### Parameters

  - ##### eventNames: TEventName

  - ##### listener: EventListener<ModuleEventData[TEventName]>

  #### Returns EventUnsubscribeFunction

  Inherited from WitnessWrapper.on

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:50

### onAny

- onAny(listener): EventUnsubscribeFunction

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns EventUnsubscribeFunction

  Inherited from WitnessWrapper.onAny

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:51

### once

- once<TEventName>(eventName, listener): EventUnsubscribeFunction

- #### Type Parameters

  - #### TEventName extends keyof ModuleEventData

  #### Parameters

  - ##### eventName: TEventName

  - ##### listener: EventListener<ModuleEventData[TEventName]>

  #### Returns EventUnsubscribeFunction

  Inherited from WitnessWrapper.once

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:52

### previousHash

- previousHash(): Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

- #### Returns Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

  Inherited from WitnessWrapper.previousHash

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:53

### query

- query<T>(query, payloads?): Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

  Inherited from WitnessWrapper.query

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:54

### queryable

- queryable<T>(query, payloads?): Promisable<boolean, never>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promisable<boolean, never>

  Inherited from WitnessWrapper.queryable

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:55

### resolve

- resolve<TModule>(filter?): Promise<TModule[]>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule> = Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Parameters

  - ##### `Optional` filter: ModuleFilter

  #### Returns Promise<TModule[]>

  Inherited from WitnessWrapper.resolve

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:56
- resolve<TModule>(nameOrAddress): Promise<undefined | TModule>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule> = Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Parameters

  - ##### nameOrAddress: string

  #### Returns Promise<undefined | TModule>

  Inherited from WitnessWrapper.resolve

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:57

### resolveWrapped

- resolveWrapped<T>(wrapper, filter?): Promise<T[]>

- Resolves the supplied filter into wrapped modules

  ### Example

  Example using ArchivistWrapper

      const filter = { address: [address] }
      const mods: ArchivistWrapper[] = await node.resolveWrapped(ArchivistWrapper, filter)

  #### Type Parameters

  - #### T extends ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>, T> = ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>>

  #### Parameters

  - ##### wrapper: ConstructableModuleWrapper<T>

    The ModuleWrapper class (ArchivistWrapper, DivinerWrapper, etc.)

  - ##### `Optional` filter: ModuleFilter

    The ModuleFilter

  #### Returns Promise<T[]>

  An array of ModuleWrapper instances corresponding to the underlying modules matching the supplied filter

  Inherited from WitnessWrapper.resolveWrapped

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:69
- resolveWrapped<T>(wrapper, nameOrAddress): Promise<undefined | T>

- #### Type Parameters

  - #### T extends ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>, T> = ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>>

  #### Parameters

  - ##### wrapper: ConstructableModuleWrapper<T>

  - ##### nameOrAddress: string

  #### Returns Promise<undefined | T>

  Inherited from WitnessWrapper.resolveWrapped

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:70

### `Protected` sendQuery

- sendQuery<T>(queryPayload, payloads?): Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### queryPayload: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

  Inherited from WitnessWrapper.sendQuery

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:74

### `Protected` throwErrors

- throwErrors(query, result): void

- #### Parameters

  - ##### query: [SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }, (SchemaFields & PayloadFields & {
    schema: string;
    })[]]

  - ##### result: undefined | ModuleQueryResult<SchemaFields & PayloadFields & {
    schema: string;
    }>

  #### Returns void

  Inherited from WitnessWrapper.throwErrors

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:75

### `Static` canWrap

- canWrap(module?): boolean

- #### Parameters

  - ##### `Optional` module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Returns boolean

  Inherited from WitnessWrapper.canWrap

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:37

### `Static` hasRequiredQueries

- hasRequiredQueries(module): boolean

- #### Parameters

  - ##### module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Returns boolean

  Inherited from WitnessWrapper.hasRequiredQueries

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:38

### `Static` missingRequiredQueries

- missingRequiredQueries(module): string[]

- #### Parameters

  - ##### module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Returns string[]

  Inherited from WitnessWrapper.missingRequiredQueries

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:39

### `Static` tryWrap

- tryWrap<TModuleWrapper>(this, module?, account?): undefined | TModuleWrapper

- #### Type Parameters

  - #### TModuleWrapper extends ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>, TModuleWrapper>

  #### Parameters

  - ##### this: ConstructableModuleWrapper<TModuleWrapper>

  - ##### `Optional` module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  - ##### `Optional` account: AccountInstance

  #### Returns undefined | TModuleWrapper

  Inherited from WitnessWrapper.tryWrap

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:40

### `Static` wrap

- wrap<TModuleWrapper>(this, module?, account?): TModuleWrapper

- #### Type Parameters

  - #### TModuleWrapper extends ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>, TModuleWrapper>

  #### Parameters

  - ##### this: ConstructableModuleWrapper<TModuleWrapper>

  - ##### `Optional` module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  - ##### `Optional` account: AccountInstance

  #### Returns TModuleWrapper

  Inherited from WitnessWrapper.wrap

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:41

Generated using TypeDoc